// one line to give the program's name and an idea of what it does.
// Copyright (C) 2005  name of Borja Snchez Zamorano
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using Forms = System.Windows.Forms;
using System.Reflection;
using System.Collections;

namespace MonoCalendar.ListView
{
	public class ListViewItem {
		System.Drawing.Color color;
		bool check;
		String text;
		Object tag;

		public bool Checked {
			get {
				return check;
			}
			set {
				check = value;
			}
		}
		public System.Drawing.Color Color {
			get {
				return color;
			}
			set {
				color = value;
			}
		}
		public Object Tag {
			get {
				return tag;
			}
			set {
				tag = value;
			}
		}
		public String Text {
			get {
				return text;
			}
			set {
				text = value;
			}
		}		
	}

	internal class Content : System.Windows.Forms.Control {
		Bitmap _offBmp = null;
		Pen pen1;
		SolidBrush sb1;
		Image imgcheck, imguncheck;
		ListViewItem selected = null;
		ArrayList items;
		int heightList;
		int heightItem;
		int scrollValue = 0;
		bool isFocused = true;
		private System.Windows.Forms.TextBox textBox1;
		
		internal Content()
		{
			this.SetStyle(Forms.ControlStyles.DoubleBuffer, true);
			this.SetStyle(Forms.ControlStyles.UserPaint, true);
			this.SetStyle(Forms.ControlStyles.AllPaintingInWmPaint, true);
			this.SetStyle(Forms.ControlStyles.UserMouse, true);
			this.SetStyle(Forms.ControlStyles.ResizeRedraw, false);
			this.SetStyle(Forms.ControlStyles.Opaque, true);

			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox1.AutoSize = false;
			this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.textBox1.Font = new System.Drawing.Font("Tahoma", 8);
			this.textBox1.Location = new System.Drawing.Point(40, 48);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(80, 64);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "hola";
			this.textBox1.Visible = false;
			this.textBox1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.TextBox1KeyDown);
			this.textBox1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TextBox1KeyPress);
			this.textBox1.Leave += new System.EventHandler(this.TextBox1Leave);
			this.Controls.Add(this.textBox1);

			this.Resize += new System.EventHandler(this.ContentResize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.ContentPaint);
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ContentMouseDown);

			pen1 = new Pen(Color.Empty);
			sb1 = new SolidBrush(Color.Empty);
			items = new ArrayList();
			imgcheck = GetResourceImage("checked.png");
			imguncheck = GetResourceImage("unchecked.png");
		}

		Image GetResourceImage (string name)
		{
			Assembly assembly = System.Reflection.Assembly.GetCallingAssembly();
			System.IO.Stream s = assembly.GetManifestResourceStream (name);
			return Image.FromStream(s);
		}
		
		void ContentResize(object sender, System.EventArgs e)
		{
			IsChangeText();
			Repaint2();
		}

		int Height2()
		{
			if (this.ClientRectangle.Height > heightList)
				return this.ClientRectangle.Height;
			return heightList;
		}

		void Repaint2()
		{
			if ((this.ClientRectangle.Width<1) || (this.ClientRectangle.Height<1)) return;
			if ((_offBmp == null) || (_offBmp.Height != Height2()) || (_offBmp.Width != this.ClientRectangle.Width)) {
				if (_offBmp != null) _offBmp.Dispose();
				_offBmp = new Bitmap( this.ClientRectangle.Width, Height2());
			}
			Graphics _g = Graphics.FromImage( _offBmp );
		  
			_g.Clear(Color.White);
			PaintWidget(_g);
			_g.Dispose();
			Paint2();
		}

		void Paint2()
		{
			if ((_offBmp == null) || (_offBmp.Height != Height2()) || (_offBmp.Width != this.ClientRectangle.Width)) {
				Repaint2();
				return;
			}

			if ((this.ClientRectangle.Width<1) || (this.ClientRectangle.Height<1)) return;

			IntPtr hwnd = new IntPtr();
			hwnd = this.Handle;
	    Graphics drawingSurface = Graphics.FromHwnd(hwnd);
	    drawingSurface.DrawImage(_offBmp, 0, -(scrollValue * heightItem));
	    if ((-(scrollValue * heightItem) + _offBmp.Height) < this.ClientRectangle.Height) {
		    sb1.Color = Color.FromArgb(255,255,255,255);
		    drawingSurface.FillRectangle(sb1, new Rectangle(0,-(scrollValue * heightItem) + _offBmp.Height,this.ClientRectangle.Width, this.ClientRectangle.Height - (-(scrollValue * heightItem) + _offBmp.Height)));
	    }
	    drawingSurface.Dispose();
		}

		void ContentPaint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			e.Graphics.DrawImage(_offBmp, 0,-(scrollValue * heightItem));
	    if ((-(scrollValue * heightItem) + _offBmp.Height) < this.ClientRectangle.Height) {
		    sb1.Color = Color.FromArgb(255,255,255,255);
		    e.Graphics.FillRectangle(sb1, new Rectangle(0,-(scrollValue * heightItem) + _offBmp.Height,this.ClientRectangle.Width, this.ClientRectangle.Height - (-(scrollValue * heightItem) + _offBmp.Height)));
	    }
		}

		void DrawFillVGradient(Graphics g_, Rectangle rect1, Color color1, Color color2)
		{
			System.Int32 r, g, b, a;
			for (int i=0; i<rect1.Height; i++) {
				a = color2.A+((((rect1.Height-1)-i)*(color1.A-color2.A))/(rect1.Height-1));
				r = color2.R+((((rect1.Height-1)-i)*(color1.R-color2.R))/(rect1.Height-1));
				g = color2.G+((((rect1.Height-1)-i)*(color1.G-color2.G))/(rect1.Height-1));
				b = color2.B+((((rect1.Height-1)-i)*(color1.B-color2.B))/(rect1.Height-1));
				pen1.Color = Color.FromArgb(a, r, g, b);
				g_.DrawLine(pen1, rect1.Left, rect1.Top+i, rect1.Right-1, rect1.Top+i);
			}
		}

		void PaintWidget(Graphics g)
		{
			Font font1 = new Font("Tahoma", 8);
			StringFormat align1 = new StringFormat();
			align1.Alignment = StringAlignment.Near;
			int i=0;
			bool sel = false;
			heightItem = (font1.Height+4);
			foreach (ListViewItem item in items) {
				heightList = heightItem * i;

				if (item == selected) {
					sel = true;
					Rectangle rect5 = new Rectangle(0,heightList+1,this.ClientRectangle.Width, heightItem - 1);
					if (isFocused) {
						pen1.Color = Color.FromArgb(255, 61, 123, 218);
						g.DrawLine(pen1, 0, heightList, this.ClientRectangle.Width, heightList);
						DrawFillVGradient(g, rect5, Color.FromArgb(255, 89, 153, 229), Color.FromArgb(255, 31, 92, 207));
					} else {
						pen1.Color = Color.FromArgb(255, 139, 139, 139);
						g.DrawLine(pen1, 0, heightList, this.ClientRectangle.Width, heightList);
						DrawFillVGradient(g, rect5, Color.FromArgb(255, 159, 159, 159), Color.FromArgb(255, 119, 119, 119));
					}
				}

				Rectangle destRect1;
				destRect1 = new Rectangle(1+(23-imguncheck.Width)/2, 1+heightList+((heightItem-imguncheck.Height)/2), imguncheck.Width-2, imguncheck.Height-2);
				sb1.Color = item.Color;
				g.FillRectangle(sb1,destRect1);
				Rectangle rect1 = new Rectangle((23-imguncheck.Width)/2, heightList+((heightItem-imguncheck.Height)/2), imguncheck.Width, imguncheck.Height);
				Rectangle rect2 = rect1;
				rect2.Y = rect1.Y + 1;
				rect2.Height = (rect1.Height/2)-2;
				DrawFillVGradient(g, rect2, Color.FromArgb(183, 255, 255, 255), Color.FromArgb(80, 255, 255, 255));
				Rectangle rect3 = rect2;
				rect3.Y = rect2.Bottom + 1;
				rect3.Height = rect1.Height - rect2.Height - 3;
				DrawFillVGradient(g, rect3, Color.FromArgb(80, 255, 255, 255), Color.FromArgb(177, 255, 255, 255));

				pen1.Color = item.Color;
				g.DrawLine(pen1, rect1.Left+1, rect1.Top, rect1.Right-2, rect1.Top);
				g.DrawLine(pen1, rect1.Left+1, rect1.Bottom-1, rect1.Right-2, rect1.Bottom-1);
				g.DrawLine(pen1, rect1.Left, rect1.Top+1, rect1.Left, rect1.Bottom-2);
				g.DrawLine(pen1, rect1.Right-1, rect1.Top+1, rect1.Right-1, rect1.Bottom-2);

				System.Drawing.Imaging.ImageAttributes ia = new System.Drawing.Imaging.ImageAttributes();
				ia.SetWrapMode(WrapMode.Tile);
				destRect1 = new Rectangle((23-imgcheck.Width)/2, heightList+((heightItem-imgcheck.Height)/2), imgcheck.Width, imgcheck.Height);
				if (item.Checked) {
					g.DrawImage(imgcheck, destRect1, 0, 0, imgcheck.Width, imgcheck.Height, GraphicsUnit.Pixel, ia);
				} else {
					g.DrawImage(imguncheck, destRect1, 0, 0, imguncheck.Width, imguncheck.Height, GraphicsUnit.Pixel, ia);
				}
				ia.Dispose();

				if (item==selected)
					sb1.Color = Color.FromArgb(255, 255, 255, 255);
				else
					sb1.Color = Color.FromArgb(255, 0, 0, 0);
				g.DrawString(item.Text, font1, sb1, 21, heightList+2, align1);
				i++;
			}
			heightList = (items.Count) * heightItem;
			font1.Dispose();
			align1.Dispose();			
			if ((sel == false) && (items.Count>0)) {
				Selected = (ListViewItem) items[0];
			}
		}

		public int HeightList {
			get {
				return heightList;
			}
			set {
				heightList = value;
			}
		}

		public int HeightItem {
			get {
				return heightItem;
			}
			set {
				heightItem = value;
			}
		}
		
		public ArrayList Items {
			get {
				return items;
			}
			set {
				items = value;
			}
		}

		public int ScrollValue {
			get {
				return scrollValue;
			}
			set {
				IsChangeText();
				scrollValue = value;
				Repaint2();
			}
		}

		public ListViewItem Selected {
			get {
				return selected;
			}
			set {
				if (selected != value) {
					selected = value;
					Repaint2();
					SelectedChanged(this, null);
				}
			}
		}

		void ContentMouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			IsChangeText();
			int i = 0;
			int Y = e.Y +(scrollValue * heightItem);
			foreach (ListViewItem item in items) {
				heightList = heightItem * i;
				if ( (Y >= HeightList) && (Y < (HeightList + heightItem)) ) {
					if (e.X < 23) {
						item.Checked = !item.Checked;
						CheckedChanged(item);
					} else {
						selected = item;
						OnSelectedChanged(this, null);
						if (e.Clicks == 2) {
							EditLabel();
						}
					}
					Repaint2();
				}
				i++;
			}
		}

		public void SelectItem(ListViewItem item)
		{
			selected = item;
		}

		public void UpdateList()
		{
			Repaint2();
		}

		public bool IsFocused {
			get {
				return isFocused;
			}
			set {
				isFocused = value;
				Repaint2();
			}
		}
		
		public void CheckedChanged(ListViewItem item)
		{
			if (OnCheckedChanged != null) OnCheckedChanged(item);
		}

		public void AfterLabelEdit(ListViewItem item)
		{
			if (OnAfterLabelEdit != null) OnAfterLabelEdit(item);
		}

		public void SelectedChanged(object o, System.EventArgs e)
		{
			if (OnSelectedChanged != null) OnSelectedChanged(o, e);
		}

		public event EventHandler OnSelectedChanged;
		public event ItemHandler OnAfterLabelEdit;
		public event ItemHandler OnCheckedChanged;

		void IsChangeText()
		{
			if (textBox1.Visible == true) {
				if (Selected.Text != textBox1.Text) {
					Selected.Text = textBox1.Text;
					AfterLabelEdit(selected);
				}
				textBox1.Visible = false;
				Repaint2();
			}
		}

		public void EditLabel() {
			int i=0;
			foreach (ListViewItem item in items) {
				if (item == selected) break;
				i++;
			}
			textBox1.Left = 23;
			textBox1.Top = (i*heightItem) -(scrollValue * heightItem)+1;
			textBox1.Height = heightItem-2;
			textBox1.Width = this.ClientRectangle.Width - 24;
			textBox1.Visible = true;
			textBox1.Text = selected.Text;
			textBox1.SelectAll();
			textBox1.Focus();
		}

		void TextBox1Leave(object sender, System.EventArgs e)
		{
			IsChangeText();
		}

		private Forms.Keys keyPressed;

		void TextBox1KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			keyPressed = e.KeyCode;
		}

		void TextBox1KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			switch (keyPressed) {
				case Forms.Keys.Escape:
					textBox1.Text = Selected.Text;
					IsChangeText();
					e.Handled = true;
					break;
				case Forms.Keys.Enter:
					IsChangeText();
					e.Handled = true;
					break;
			}
		}
		
	}
}
